// DSLR Notifier

const dslrVersion = "1.0";
const dslrPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("reportstatus.");
const siteName = dslrPref.getCharPref("siteName", "broadbandreports.com");

var _poller = false;
var _factor = 60000;

var dslrPrefObserve = {

	register: function()
		{
			var prefObs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			this._branch = prefObs.getBranch("reportstatus.");
			var prefInt = this._branch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
			prefInt.addObserver('', this, false);
		},
	
	unregister: function()
		{
			if (!this._branch) 
				{ return; }
			
			var prefInt = this._branch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
			prefInt.removeObserver('', this);
		},
	
	observe: function(aSubject, aTopic, aData)
		{
			if(aTopic != "nsPref:changed") { return; }
			
				var topChange = dslrPref.getBoolPref("newsFlag");
				var imChange = dslrPref.getBoolPref("imFlag");
				var logChange = dslrPref.getBoolPref("loginFlag");
				var shIco = dslrPref.getIntPref("icoPref");
				var pollImFlag = dslrPref.getBoolPref("pollIm");
				var pollTopFlag = dslrPref.getBoolPref("pollTop");
				var dispPos = dslrPref.getIntPref("statusPos");
				var dispName = dslrPref.getCharPref("placeHere");
				var imSlide = dslrPref.getBoolPref("imSlide");
				var topSlide = dslrPref.getBoolPref("topSlide");
				var topPop = dslrPref.getBoolPref("topPop");
				var imPop = dslrPref.getBoolPref("poppref");
				var errStr = dslrPref.getCharPref("errStr");
				
				/*if (dispPos == 0) {
					document.getElementById('dslr-iconset').setAttribute('insertafter', "");
					document.getElementById('dslr-iconset').setAttribute('insertbefore', "");
				}
				
				if (dispPos == 1) {
					document.getElementById('dslr-iconset').setAttribute('insertbefore', dispName);
					document.getElementById('dslr-iconset').setAttribute('insertafter', "");
				}
				
				if (dispPos == 2) {
					document.getElementById('dslr-iconset').setAttribute('insertafter', dispName);
					document.getElementById('dslr-iconset').setAttribute('insertbefore', "");
				}*/
								
				if ((shIco == 0) && (logChange != true)) {
					document.getElementById('dslr-menu').setAttribute('hidden', 'false');
				}				
				
				else {
					document.getElementById('dslr-menu').setAttribute('hidden', 'true');
				}
				
				if ((topChange == true) && (shIco != 2) && (pollTopFlag == true)) {
					// Show topic icon
					document.getElementById('dslr-newsbar').setAttribute('hidden', 'false');
					document.getElementById('dslr-newspix').setAttribute('tooltiptext', dslrPref.getCharPref("newsText"));
				}
				
				else {
					// Disable topic icon
					document.getElementById('dslr-newsbar').setAttribute('hidden', 'true');
				}
				
				if ((topChange == true) && (topSlide == true) && (logChange == false)) {
					
					try {
						alertSlide.doAlert(0,1);
					}
					catch (e) { dump(e); }
				}
				
				if ((topChange == true) && (topPop == true)) {
					alertPop(0,1);
				}
				
				if ((imChange == true) && (shIco != 2) && (pollImFlag == true)) {
					// Show IM icon
					document.getElementById('dslr-imbar').setAttribute('hidden', 'false');
					document.getElementById('dslr-impix').setAttribute('tooltiptext', dslrPref.getCharPref("imText"));
				}
				
				else {
					// Disable IM icon
					document.getElementById('dslr-imbar').setAttribute('hidden', 'true');
				} 
				
				if ((imChange == true) && (imSlide == true) && (logChange == false)) {
					
					try {
						alertSlide.doAlert(1,0);
					}
					catch (e) { dump(e); }
				}
				
				if ((imChange == true) && (imPop == true)) {
					alertPop(1,0);
				}
				
				if ((logChange == true) && (shIco != 2)) {
					// Show Login Flag and turn off all others
					document.getElementById('dslr-loginbar').setAttribute('hidden', 'false');
					document.getElementById('dslr-loginpix').setAttribute('tooltiptext', errStr);
					document.getElementById('dslr-newsbar').setAttribute('hidden', 'true');
					document.getElementById('dslr-imbar').setAttribute('hidden', 'true');					
				}
				
				else {
					// Disable login icon
					document.getElementById('dslr-loginbar').setAttribute('hidden', 'true');
				}
				
				// Check if the toolbar icon exists
				if(document.getElementById('dslr-toolbar-item')) {
					
					document.getElementById('placeholder').setAttribute('src', 'chrome//reportstatus/content/images/bbrfav.png');
					
					// Normal status
					if ((topChange == false) && (imChange == false) && (logChange == false)) {
						document.getElementById('dslr-toolbar-item').setAttribute('class', 'dslrtoolnorm toolbarbutton-1 chromeclass-toolbar-additional');
						document.getElementById('dslr-toolbar-item').setAttribute('tooltiptext', 'DSLR Notifier');
					}
					
					// IM notification
					if ((topChange == false) && (logChange == false) && (imChange == true)) {
						document.getElementById('dslr-toolbar-item').setAttribute('class', 'dslrtoolim toolbarbutton-1 chromeclass-toolbar-additional'); 
						document.getElementById('dslr-toolbar-item').setAttribute('tooltiptext', dslrPref.getCharPref("imText"));
					}
					
					// Topic notification
					if ((imChange == false) && (logChange == false) && (topChange == true)) {
						document.getElementById('dslr-toolbar-item').setAttribute('class', 'dslrtoolnews toolbarbutton-1 chromeclass-toolbar-additional'); 
						document.getElementById('dslr-toolbar-item').setAttribute('tooltiptext', dslrPref.getCharPref("newsText"));	
					}
					
					// Error notification
					if (logChange == true) {
						document.getElementById('dslr-toolbar-item').setAttribute('class', 'dslrtoollogin toolbarbutton-1 chromeclass-toolbar-additional'); 
						document.getElementById('dslr-toolbar-item').setAttribute('tooltiptext', errStr);
					}
					
					// Hybrid IM/Topic notification
					if ((logChange == false) && (topChange == true) && (imChange == true)) {
						document.getElementById('dslr-toolbar-item').setAttribute('class', 'dslrtoolhybrid toolbarbutton-1 chromeclass-toolbar-additional'); 
						document.getElementById('dslr-toolbar-item').setAttribute('tooltiptext', ""+dslrPref.getCharPref("imText")+" and "+dslrPref.getCharPref("newsText")+"");
					}
				}
		}
}



var PollServerTimer = {
	_timer: null,
	
	init: function(aDelay){
		
		this.cancel();
		this._timer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
		this._timer.init(this, aDelay, this._timer.TYPE_REPEATING_PRECISE);
	},

	cancel: function(){
		if(this._timer){
			this._timer.cancel();
			this._timer = null;
		}
	},
	observe: function(aSubject, aTopic, aData){
		dslrPollIt();	
	}
}


function dslrPollIt() {
	try { 
				
			// It's a total hack, but necessary... this is used to kick start the BBR icon ;) 
			var arbPref = dslrPref.getBoolPref("arbitraryPref");
			dslrPref.setBoolPref("arbitraryPref", !arbPref);
			var pollUrl = "http://www."+siteName+"/browser/extensions/reportstatus.xml?ver="+dslrVersion;
			var xmlR = new XMLHttpRequest();
			
			// Open the connection asynchronously
			xmlR.open("GET", pollUrl, true);
			xmlR.overrideMimeType("text/xml");
			function loaded () {
				
				try {
					
					if (xmlR.readyState == 4) {
						
						if(xmlR.status == 200) {
														
							var dslrDoc = xmlR.responseXML;
							var dslrElement = dslrDoc.documentElement;
							var dslrImFlag = dslrElement.getAttribute("i");
							var dslrTopFlag = dslrElement.getAttribute("n");
							var checkTop = dslrPref.getBoolPref("pollTop");
							var checkIM = dslrPref.getBoolPref("pollIm");
					
							if (dslrElement.tagName != "m") {

								dslrPref.setBoolPref("loginFlag", true);
								dslrPref.setCharPref("errStr", "Error: Check login credentials.");
								dslrPref.setBoolPref("imFlag", false);
								dslrPref.setBoolPref("newsFlag", false);
							}
					
							else {
						
								dslrPref.setBoolPref("loginFlag", false);
								dslrPref.setCharPref("errStr", "");
							}
															
							
							if ((dslrImFlag != null) && (checkIM == true)) {
						
								dslrPref.setBoolPref("imFlag", true);
								dslrPref.setCharPref("imText", dslrImFlag);
							}
					
							else {
					
								dslrPref.setBoolPref("imFlag", false);
								dslrPref.setCharPref("imText", "");
							}
					
							if ((dslrTopFlag != null) && (checkTop == true)) {
					
								// Check the offset
								var topOffset = dslrPref.getIntPref("feedOff");
								var numTop = dslrTopFlag.substring(0,2);
								if (numTop > topOffset) {
									dslrPref.setBoolPref("newsFlag", true);
									dslrPref.setCharPref("newsText", dslrTopFlag);
								}
								
								else {
									dslrPref.setBoolPref("newsFlag", false);
									dslrPref.setCharPref("newsText", "");
								}
							}
					
							else {
						
								dslrPref.setBoolPref("newsFlag", false);
								dslrPref.setCharPref("newsText", "");
							}
						
						}
						else {
							// This covers all server screwups,  so make the errStr as obscure as possible ;)
							dslrPref.setCharPref("errStr", "Error: Server sent mismatched headers.");
							dslrPref.setBoolPref("loginFlag", true);
						}
					}
					else {
					}
				}
				catch (e) { 
					// Polling failed miserably. Assume the server can't be reached.
					dslrPref.setCharPref("errStr", "Error: Server not found.");
					dslrPref.setBoolPref("loginFlag", true); 
				}
		}
		
		xmlR.onreadystatechange = loaded;
		xmlR.send(null);
	}
		catch (e) { dump(e); }
}

function onInit() {
	var firstPoll = dslrPref.getIntPref("pollFlag");
	if (firstPoll == 0) {
		dslrPref.setIntPref("pollFlag", 1);
		// Initalize update timer
		var firstFlag = dslrPref.getBoolPref("firstFlag");
				if ((typeof firstFlag != "undefined") &&  firstFlag) {
				
					dslrPref.setBoolPref("firstFlag", false);
					_poller = true;
				
					var ival = dslrPref.getIntPref("pollIntMinutes", 1);
					if (ival != -1) { PollServerTimer.init(ival*_factor); }
				
				}
				
		// Fire up the pref observer 
		dslrPrefObserve.register();
		
		// Waiting for actual content worked in earlier versions, but now just wait 10sec.
		setTimeout('dslrPollIt();',10000);
	}
}
		
var Manager = {
	_manager: null,

	stop: function() {

		if (_poller) { dslrPref.setBoolPref("firstFlag", true); }

		// Is this the last closing window?
		try{
			var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
			var browsers=wm.getZOrderDOMWindowEnumerator('navigator:browser',true);
			if(browsers.hasMoreElements()) { var browser=browsers.getNext(); }
			if(browsers.hasMoreElements()) { return; }
		}
		catch(e){ return; }
				
		// If it's the last one, it's cleanup time
		dslrPref.setBoolPref("firstFlag", true);
		dslrPref.setBoolPref("imFlag", false); 
		dslrPref.setBoolPref("newsFlag", false);
		dslrPref.setBoolPref("loginFlag", false);
		dslrPref.setCharPref("errStr", "");
		dslrPref.setCharPref("imText", ""); 
		dslrPref.setCharPref("newsText", "");
		dslrPref.setIntPref("pollFlag", 0);
		dslrPref.setBoolPref("poponce", false);
		dslrPref.setBoolPref("arbitraryPref", true);
		dslrPref.setBoolPref("toppoponce", false);
		dslrPref.setBoolPref("topslideonce", false);
		dslrPref.setBoolPref("impoponce", false);
		dslrPref.setBoolPref("imslideonce", false);
		dslrPrefObserve.unregister();
		
	}
}

function chkDis() {
	var winDis = dslrPref.getIntPref("winDis");
	if (winDis == 1) {
		var randPref = dslrPref.getBoolPref("arbitraryPref");
			if (document.getElementById('dslr-iconset')) {	
				win.dslrPrefObserve.register();
				// Make sure the icons are started...
				dslrPref.setBoolPref("arbitraryPref", !randPref);
			}
	}
}


function reReg() {
	// Instantiate  on separate windows
	var winDis = dslrPref.getIntPref("winDis");
	if (winDis == 0) {
		var randPref = dslrPref.getBoolPref("arbitraryPref");
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var win = wm.getMostRecentWindow('navigator:browser');
		win.dslrPrefObserve.unregister();
		win.dslrPrefObserve.register();
		// Make sure the icons are started...
		dslrPref.setBoolPref("arbitraryPref", !randPref);

	}
}

// FF *really* doesn't like things changing position while running... feature targeted for 1.0
function spawnMenu() {

	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var enumerator = wm.getEnumerator('navigator:browser');
	while(enumerator.hasMoreElements()) {
		var win = enumerator.getNext();	
		var barElems = win.document.getElementsByTagName("statusbarpanel");
	
		for (var i = 0; i < barElems.length; i++) {
		    if (barElems[i].id == "dslr-menu")
				continue;
			if (barElems[i].id == "dslr-imbar")
				continue;
			if (barElems[i].id == "dslr-newsbar")
				continue;
			if (barElems[i].id == "dslr-loginbar")
				continue;
				
		document.getElementById('hozpos-menu').appendItem(barElems[i].id, barElems[i].id);
		}
	}
}
 
function dslrGoTo(login,im,news,toplist) {
		if (login != false) {
			goTO("http://www."+dslrPref.getCharPref("siteName","broadbandreports.com")+"/login"); }
		if (im != false) {
			goTO("http://www."+dslrPref.getCharPref("siteName","broadbandreports.com")+"/instant?unread=1"); }
		if (news != false) {
			goTO("http://www."+dslrPref.getCharPref("siteName","broadbandreports.com")+"/postlist?cat=umarked"); }
		if (toplist) {
			goTO("http://www."+dslrPref.getCharPref("siteName","broadbandreports.com")+"/postlist?cat=marked"); }
}
function dslrGoCur(login,im,news) {
		if (login != false) {
			loadURI("http://www."+dslrPref.getCharPref("siteName","broadbandreports.com")+"/login"); }
		if (im != false) {
			loadURI("http://www."+dslrPref.getCharPref("siteName","broadbandreports.com")+"/instant?unread=1"); }
		if (news != false) {
			loadURI("http://www."+dslrPref.getCharPref("siteName","broadbandreports.com")+"/postlist?cat=umarked"); }
}
function dslrGoMenu(current,tab,kill) {
		if (current == 1) {
				loadURI("http://www."+dslrPref.getCharPref("siteName","broadbandreports.com")+""+dslrPref.getCharPref("optSiteName")+""); }
		if (tab == 1) {
			goTO("http://www."+dslrPref.getCharPref("siteName","broadbandreports.com")+""+dslrPref.getCharPref("optSiteName")+""); }
		
}
function killNotify(im,news,login) {
		if (im != false) {
			dslrPref.setBoolPref("imFlag", false);
			dslrPref.setBoolPref("impoponce", false);
			dslrPref.setBoolPref("imslideonce", false); }
		if (news != false) {
			dslrPref.setBoolPref("newsFlag", false);
			dslrPref.setBoolPref("toppoponce", false);
			dslrPref.setBoolPref("topslideonce", false); }
		if (login != false) {
			dslrPref.setBoolPref("loginFlag", false); }
			
		setTimeout('dslrPollIt();',30000);
}

function goTO(url) {
		var brow = document.getElementById('content');
		brow.selectedTab = brow.addTab(url);
}

window.addEventListener('load', reReg, false);
window.addEventListener('close', Manager.stop, false);
window.addEventListener('close', chkDis, false);
window.addEventListener('load', onInit, false);

// Check whether or not alerts are supported
try {
	var alertServ = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
}

catch(e) {
	
	var imAlrChk = dslrPref.getBoolPref("imSlide");
	var topAlrChk = dslrPref.getBoolPref("topSlide");
	
		if ((imAlrChk == true) || (topAlrChk == true)) {
			dslrPref.setBoolPref("imSlide", false);
			dslrPref.setBoolPref("topSlide", false);
			alert("Your platform does not support alert sliders. They have been disabled.");
		}
}

var alertSlide = {
		
	doAlert: function(im,news) {
	if (im == 1) {
		try {
		var imslideonce = dslrPref.getBoolPref("imslideonce");
			if (imslideonce == false) {
				alertServ.showAlertNotification("chrome://reportstatus/content/images/imsg.gif", "Instant Message", "Go To Inbox", true, "", this);
				dslrPref.setBoolPref("imslideonce", true);
			}
		}
		catch(e) { dump(e); }
	}
	
	if (news == 1) {
		try {
		var topslideonce = dslrPref.getBoolPref("topslideonce");
			if (topslideonce == false) {
				alertServ.showAlertNotification("chrome://reportstatus/content/images/camb.gif", "Updated Topic", "Click To View", true, "", this);
				dslrPref.setBoolPref("topslideonce", true);
			}
		}
		catch(e) { dump(e); }
	}
	},
	onAlertFinished : function(aCookie) {},
	// For some reason FF 1.5 dumps on onAlertClickCallback and fails to run from extensions :/
	onAlertClickCallback: function(aCookie)
	{
		var imAlert = dslrPref.getBoolPref("imFlag");
		var topAlert = dslrPref.getBoolPref("newsFlag");
		
		if (imAlert == true) {
			dslrGoTo(false,1,false);
			killNotify(1,false,false)
		}
		
		if (topAlert == true) {
			dslrGoTo(false,false,1);
			killNotify(false,1,false)
		}
	}

}


function alertPop(im, news) {
	var imPopOnce = dslrPref.getBoolPref("impoponce");
	var topPopOnce = dslrPref.getBoolPref("toppoponce");
				
		if ((im == 1) && (imPopOnce == false)) {
			window.open("chrome://reportstatus/content/impopup.xul","DSLRpopIm","centerscreen, chrome");
			dslrPref.setBoolPref("impoponce", true);
		}
	
		if ((news == 1) && (topPopOnce == false)) {
			window.open("chrome://reportstatus/content/toppopup.xul","DSLRpopTop","centerscreen, chrome");
			dslrPref.setBoolPref("toppoponce", true);
		}
}